//New Style
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <string>

#include <math.h>
#include <time.h>
#include <ctype.h>

//#include <ilcplex/ilocplex.h>

#include <vector>
#include <set>
#include <list>
#include <queue>
#include <stack>
#include <iostream>
#include <utility>
#include <fstream>
#include <istream>
//# include <boost>
# include <iostream>
# include <ctime>
# include <cstdlib>

using namespace std;

/*
This code generates test instances for Relay Network Design Problem as follows:
|[[W]] weights or demands matrix
|[[D]] distance matrix
|[f] fixed cost array for locating RPs
|[X] x cordinate for nodes
|[Y] y cordinate for nodes
|[H] a zero/one array showing RP nodes; 1 for RPs 
*/


const int  NofNodes = 195; //total # of Nodes
const int NofCommNodes = 160;  // # of Commodity nodes
long int Fcost = 230000;//fixed cost; 230 160, 180 140, 135 120,  100 70
//******************************************
float const a = 0.8;//long distance %
float const b = 0.1;//medium distance %
float const c = 0.1;//short distance %
int Density = 35;
int delta1 = 30;//distance threshold _ short/medium
int delta2 = 60;//distance threshold _ medium/long
int  delta2Org = 40;//Delta2
int  delta1Org = 20;//Delta1
//**********************************************


int  NofRPNodes = 0;
float PofCommNodesRegion = 0.17;
int avestatus = 1;
int solstatus = 0;
int GoodAveDis = 60;
//int NofCommNodes = 0;
ofstream TestProblem("TestProblem.txt");
//ofstream TestProblemInIn("TestProblemInIn.txt");
//ofstream TestProblemIn("TestProblemIn.txt");
//ofstream Rank("Rank.txt");

int main() {
	//system("pause");
	time_t start, end;
	double total_time;
	start = clock();
	cout << "*** running ...*** " << endl;
	//////////////////////////////////////////    Demand (w)  ///////////////////////////////////////
	NofRPNodes = NofNodes - NofCommNodes;

	srand(time(0));
	int finalstatus = 0; // for O D assurance
	for (int it = 0; it < 1000000; it++) {
		finalstatus = 0;
		solstatus = 0;
		//	NofCommNodes = PofCommNodes*NofNodes;

		////////////////////////////////////////////////    Nodes       ////////////////////////////////////////
		int q1 = 1000;
		long int d[NofNodes][NofNodes];
		long int g[NofNodes][NofNodes];
		long int dstate[NofNodes];
		long int HPossibility[NofNodes];

		// New$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		for (int i = 0; i < NofNodes; i++)
			HPossibility[i] = 0;
		for (int i = 0; i < NofNodes; i++)
			//if (i>PofCommNodes*NofNodes)
			if (i >= NofCommNodes)
				HPossibility[i] = 1;
		// New$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$


		for (int i = 0; i < NofNodes; i++)
			dstate[i] = 0;



		/*for (int i = 0; i < NofNodes; i++){
		for (int j = 0; j < NofNodes; j++){
		g[i][j] = 650 * (rand() % 600) + 301;//200000;//
		//; 1500
		//w[i][j] = sqrt(16);
		}
		}
		for (int i = 0; i < NofNodes; i++){
		g[i][i] = 0;
		}*/
		////////////////////////////// f RL cost ///////////////////////
		double f[NofNodes];
		int w[NofNodes][NofNodes];

		for (int i = 0; i < NofNodes; i++) {
			f[i] = Fcost;

			//	f[i] = (rand() %2000) + 9000;
			//f[i] =  (rand() % 10000) + 5000;

			// f[i] = 1000 * (rand() % 1000) + 100;
			//	f[i] = 85*(rand() % 1000) + 100;

			//f[i] = (rand() % 190000) + 100;
			//	f[i] = (rand() % 10000) + 5000;
			//f[i] = 50 * (rand() % 1800) + 100;
			//	f[i] = 50 * (rand() % 150) + 100;
			//f[i] = 50*(rand() % 15000) +  1000;
			//;2500
			//f[1][i] = 0; 000000
			//cout << f[i] << endl;
		}


		//$$$$$$$$$$$$$$$$$$$$$$$$$$$

		//	for (int it = 0; it < 1000000; it++){
		//	if (q1 > 100){


		//$$$$$$$$$$$$$$$$$$$$

		for (int i = 0; i < NofNodes; i++) {
			for (int j = 0; j < NofNodes; j++) {
				w[i][j] = 0;// (rand() % 11) + 10;
			}
		}
		for (int i = 0; i < NofNodes; i++) {
			w[i][i] = 0;
		}

		//ofstream TestProblem("TestProblem.txt");
		//cout << "Enter Num of Nodes"<<endl;
		//system("pause");
		//cin >> NofNodes;
		for (int i = 0; i < NofNodes; i++) {
			for (int j = 0; j < NofNodes; j++) {
				d[i][j] = 0;
			}
		}
		//	double cord[NofNodes][NofNodes];


		srand(time(0));

		long int nodex[NofNodes];
		long int nodey[NofNodes];

		//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
		//   partitioning based on uster TS paper 6/8 in boxes, 2/8 scattered

		int RegionCounter = 0;
		//float sixthregionselection = rand();

		//1
		int s1 = -1;
		//for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
		for (int i = 0; i < PofCommNodesRegion*NofCommNodes; i++) {
			nodex[i] = (rand() % 29) + 1;////////////////////////
			s1 += 1;
		}

		//a

		double RegionSel = ((rand() % 99) + 1) * 0.01;

		int ss1 = -1;
		if (RegionSel <= 0.2) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion - 1; i++){
			for (int i = 0; i < PofCommNodesRegion*NofCommNodes; i++) {

				nodey[ss1 + 1] = (rand() % 19) + 1;
				ss1 += 1;

			}
		}
		if (RegionSel > 0.2 && RegionSel <= 0.4) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < PofCommNodesRegion*NofCommNodes; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 20;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.4 && RegionSel <= 0.6) {

			//for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 40;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.6 && RegionSel <= 0.8) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 60;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.8) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 80;
				ss1 += 1;
			}
		}




		//a	ss1 = s1;



		//a

		//2
		//for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
		for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

			nodex[s1 + 1] = (rand() % 30) + 30;/////////////////
			s1 += 1;
		}

		//a
		RegionSel = ((rand() % 99) + 1) * 0.01;
		if (RegionSel <= 0.2) {
			//for (int i = 0; i < NofNodes*PofCommNodesRegion - 1; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 19) + 1;
				ss1 += 1;

			}
		}
		if (RegionSel > 0.2 && RegionSel <= 0.4) {
			//for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 20;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.4 && RegionSel <= 0.6) {

			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 40;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.6 && RegionSel <= 0.8) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 60;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.8) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 80;
				ss1 += 1;
			}
		}

		//a		ss1 = s1;



		//3
		//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
		for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

			nodex[s1 + 1] = (rand() % 30) + 60;//////////////////////
			s1 += 1;
		}

		RegionSel = ((rand() % 99) + 1) * 0.01;
		if (RegionSel <= 0.25) {
			//for (int i = 0; i < NofNodes*PofCommNodesRegion - 1; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 19) + 1;
				ss1 += 1;

			}
		}
		if (RegionSel > 0.25 && RegionSel <= 0.5) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 20;
				ss1 += 1;
			}
		}

		if (RegionSel > 0.5 && RegionSel <= 0.75) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 60;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.75) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 80;
				ss1 += 1;
			}
		}
		/////////////////

		//a	ss1 = s1;

		//4
		//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
		for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

			nodex[s1 + 1] = (rand() % 30) + 60;
			s1 += 1;
		}

		//for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
		for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

			nodey[ss1 + 1] = (rand() % 20) + 40;
			ss1 += 1;
		}

		/////////////////

		//a	ss1 = s1;



		//5

		//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
		for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

			nodex[s1 + 1] = (rand() % 30) + 90;///////////////////////
			s1 += 1;
		}

		RegionSel = ((rand() % 99) + 1) * 0.01;
		if (RegionSel <= 0.2) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion - 1; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 19) + 1;
				ss1 += 1;

			}
		}
		if (RegionSel > 0.2 && RegionSel <= 0.4) {
			//for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 20;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.4 && RegionSel <= 0.6) {

			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 40;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.6 && RegionSel <= 0.8) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 60;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.8) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < NofCommNodes*PofCommNodesRegion; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 80;
				ss1 += 1;
			}
		}


		//a	ss1 = s1;

		//6				
		//	int s3 = s1;
		int ali = (NofCommNodes - s1 - 1);
		//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
		for (int i = 0; i < ali; i++) {//NofCommNodes-s1-1

			nodex[s1 + 1] = (rand() % 30) + 120;////////////////////////
			s1 += 1;

		}

		RegionSel = ((rand() % 99) + 1) * 0.01;
		if (RegionSel <= 0.2) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion - 1; i++){
			for (int i = 0; i < ali; i++) {

				nodey[ss1 + 1] = (rand() % 19) + 1;
				ss1 += 1;

			}
		}
		if (RegionSel > 0.2 && RegionSel <= 0.4) {
			//for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < ali; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 20;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.4 && RegionSel <= 0.6) {

			///	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < ali; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 40;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.6 && RegionSel <= 0.8) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < ali; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 60;
				ss1 += 1;
			}
		}
		if (RegionSel > 0.8) {
			//	for (int i = 0; i < NofNodes*PofCommNodesRegion; i++){
			for (int i = 0; i < ali; i++) {

				nodey[ss1 + 1] = (rand() % 20) + 80;
				ss1 += 1;
			}
		}

		//7,8
		//	cout << s1 << endl;
		//	system("pause");
		int s3 = s1;
		for (int i = 0; i < NofNodes - s3 - 1; i++) {
			//	nodex[s1 + 1] = (rand() % 100) + 25;
			//	nodey[s1 + 1] = (rand() % 70) + 15;

			//		nodex[s1 + 1] = (rand() % 50) + 50;//80
			//		nodey[s1 + 1] = (rand() % 30) + 35;//80
			//		nodex[s1 + 1] = (rand() % 40) + 55;
			//	    nodey[s1 + 1] = (rand() % 20) + 40;
			nodex[s1 + 1] = (rand() % 140) + 5;
			nodey[s1 + 1] = (rand() % 90) + 5;
			s1 += 1;
		}

		//	cout << s1 << endl;
		//	system("pause");

		//99999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999
		//$$$$$$$$$$$$$$

		for (int i = 0; i < NofNodes; i++) {
			for (int j = 0; j < NofNodes; j++) {
				double	 d2 = (pow((nodex[i] - nodex[j]), 2) + pow((nodey[i] - nodey[j]), 2));
				d[i][j] = sqrt(d2);
			}
		}





		////////////////////////////// g arc cost ///////////////////////
		/*	int g[NofNodes][NofNodes];

		for (int i = 0; i < NofNodes; i++){
		for (int j = 0; j < NofNodes; j++){
		g[i][j] = 600;
		//w[i][j] = sqrt(16);
		}
		}
		for (int i = 0; i < NofNodes; i++){
		g[i][i] = 0;
		}
		////////////////////////////// f RL cost ///////////////////////
		int f[NofNodes];

		for (int i = 0; i < NofNodes; i++){
		f[i] = (rand() % 10000) + 5001;
		//f[1][i] = 0;
		}*/



		/////////////////////////////////////////////////////////// for revised flow



		int sizedis = ((NofNodes *NofNodes) - NofNodes) / 2;
		float disrnk[((NofNodes *NofNodes) - NofNodes) / 2];
		int sizedisCommNodes = ((NofCommNodes *NofCommNodes) - NofCommNodes);


		int kk = 0;
		for (int i = 0; i < NofNodes; i++) {
			for (int j = i + 1; j < NofNodes; j++) {

				disrnk[kk] = d[i][j];
				kk = kk + 1;

			}
		}


		for (int kkk = 0; kkk < sizedis - 1; kkk++) {
			for (int l = kkk + 1; l < sizedis; l++) {
				float temp;
				if (disrnk[kkk] > disrnk[l]) {
					temp = disrnk[kkk];
					disrnk[kkk] = disrnk[l];
					disrnk[l] = temp;
				}
			}
		}
		//int q1 = (disrnk[sizedis - 1] - disrnk[0])*0.3333333333;
		//int q3 = (disrnk[sizedis - 1] - disrnk[0]) * 2 * (0.3333333333);

		int a1 = (sizedis - 1)*0.3333333333;
		int a2 = (sizedis - 1) * 2 * 0.3333333333;

		q1 = disrnk[a1];
		int q3 = disrnk[a2];
		//	for (int kkk = 0; kkk < sizedis; kkk++)
		//		Rank << disrnk[kkk] << endl;
		//	Rank << "q1=" << q1 << endl;
		//Rank << q1 << endl;
		//	Rank << "q3=" << q3 << endl;
		//	Rank << q3 << endl;


		//cout << disrnk[0] << endl;
		//	cout << disrnk[sizedis - 1] << endl;
		for (int kkk = 0; kkk < sizedis; kkk++) {
			//	cout << disrnk[kkk] << endl;
		}
		//	system("pause");
		srand(time(0));



		int amin = 0;
		int ld = 0;
		//for (int i = 0; i < 100 * NofNodes; i++){
		//	if (ld < ((a)*(0.01*(Density)) * sizedisCommNodes) - 1){
		while (ld < ((a)*(0.01*(Density)) * sizedisCommNodes) - 1) {
			///////////

			end = clock();
			total_time = (double)(end - start) / (double)CLK_TCK;
			if (total_time > 3) {
			//	cout << "         annnnnnnnnnnnnnn" << endl;
				start = end;
				amin = 10;
				break;
			}
			/////


			//	for (int j = 0; j < 100 * NofNodes; j++){
			//	if (ld < ((a)*(0.01*(Density)) * sizedisCommNodes) - 1){
			//	if (i + 1 != j + 1){
			int ll = (rand() % NofNodes);
			int mm = (rand() % NofNodes);
			if (ll + 1 != mm + 1) {

				if ((ll < NofCommNodes) && (mm < NofCommNodes)) {

					if (d[ll][mm] > delta2) {// to ensure long
						if (w[ll][mm] == 0) {

							long int councount1 = 0;

							int l2 = 0;
							int l3 = 0;
							int delta1orgstatus = 0; int delta1orgstatus1 = 0;
							//while ((delta1orgstatus == 0) || (delta1orgstatus12 == 0)){


							for (int l2 = 0; l2 < NofNodes - NofCommNodes; l2++) {

								if ((d[ll][l2 + NofCommNodes] <= delta1Org)) {
									delta1orgstatus = 1;
									if (delta1orgstatus == 1) {
										//	cout << " Long1: done" << endl;

										for (int l3 = 0; l3 < NofNodes - NofCommNodes; l3++) {


											if ((d[mm][l3 + NofCommNodes] <= delta1Org)) {
												w[ll][mm] = (rand() % 11) + 10;
												ld += 1;
												delta1orgstatus1 = 1;
												//cout << " Long2: done" << endl;
												break;
											}
											//	else if (l3 == NofNodes - NofCommNodes - 1) { cout << " Long2: Not done" << endl; }


										}



									}


								}

								if (delta1orgstatus1 == 1) {

									//	cout << " Long2: done" << endl;
									break;
								}
								//	else if (l2 == NofNodes - NofCommNodes-1) { cout << " Long1: Not done" << endl; }
							}


						}
					}
				}
			}
			//	}
			//	}
			//		else { break; }
			//		}
			//	}
			//	else { break; }
		}
		//	cout << ld << endl;
		if (amin != 10) {
			int md = 0;
			//	for (int i = 0; i < 100 * NofNodes; i++){
			//if (md < ((b)*(0.01*(Density)) * sizedisCommNodes)){
			while (md < ((b)*(0.01*(Density)) * sizedisCommNodes)) {

				//	for (int j = 0; j < 100 * NofNodes; j++){
				//		if (md < ((b)*(0.01*(Density)) * sizedisCommNodes)){
				//			if (i + 1 != j + 1){
				int lll = (rand() % NofNodes);
				int mmm = (rand() % NofNodes);
				if (lll + 1 != mmm + 1) {

					if ((lll < NofCommNodes) && (mmm < NofCommNodes)) {

						if (d[lll][mmm] < delta2) {
							if (delta1 < d[lll][mmm]) {
								if (w[lll][mmm] == 0) {




									int l2 = 0;
									int l3 = 0;
									int delta1orgstatus = 0; int delta1orgstatus1 = 0; int delta1orgstatus12 = 0;
									//while ((delta1orgstatus == 0) || (delta1orgstatus12 == 0)){
									for (int l2 = 0; l2 < NofNodes - NofCommNodes; l2++) {

										//l2 = (rand() % (NofNodes - NofCommNodes)) + NofCommNodes;

										if ((d[lll][l2 + NofCommNodes] <= delta1Org)) {
											delta1orgstatus = 1;
											if (delta1orgstatus == 1) {

												//	cout << " Med1: done" << endl;
												for (int l3 = 0; l3 < NofNodes - NofCommNodes; l3++) {

													if ((d[mmm][l3 + NofCommNodes] <= delta1Org)) {

														w[lll][mmm] = (rand() % 11) + 10;
														md += 1;
														delta1orgstatus1 = 1;
														//	cout << " Med2: done" << endl;
														delta1orgstatus12 = 1;
														break;
													}
													//	else if (l3 == NofNodes - NofCommNodes - 1) { cout << " Med2: Not done" << endl; }

												}
											}
										}
										if (delta1orgstatus1 == 1) {

											break;
										}
										//else if (l2 == NofNodes - NofCommNodes - 1) { cout << " Med1: Not done" << endl; }
									}

								}
							}
						}
					}
				}
				//		}
				//		}

				//	else {
				//		break;
				//	}
				//	}
				//	}
				//	else {
				//cout << "amin" << endl;
				//		break;
				//	}
			}
			//		cout << md << endl;

			/*	int countCC = (((0.01*(Density)) * sizedisCommNodes) - int (((a + b)*(0.01*(Density)) * sizedisCommNodes)));
			float countCCC = (((0.01*(Density)) * sizedisCommNodes) - (((a + b)*(0.01*(Density)) * sizedisCommNodes)));

			float countC = 0;
			cout << countCCC- countCC << endl;
			//	cout << countCCC << endl;
			if (countCCC - countCC >0.0001){
			countC = countCCC;
			}
			else{ countC = countCCC-1 ;
			}
			*/
			int sd = 0;
			//	for (int i = 0; i < 1000 * NofNodes; i++){
			//	if (sd <int(((0.01*(Density)) * sizedisCommNodes) - int(((a + b)*(0.01*(Density)) * sizedisCommNodes))) - 1){
			//while (sd <int(((0.01*(Density)) * sizedisCommNodes) - int(((a + b)*(0.01*(Density)) * sizedisCommNodes))) - 1){//
			while (sd < (c*0.01*Density * sizedisCommNodes) - 1) {
				//	for (int j = 0; j < 1000 * NofNodes; j++){
				//	if (sd < ((c)*(0.01*(Density)) * sizedisCommNodes) - 1){
				//	if (sd <int(((0.01*(Density)) * sizedisCommNodes) - int(((a + b)*(0.01*(Density)) * sizedisCommNodes))) - 1){

				//	if (i + 1 != j + 1){
				int llll = (rand() % NofNodes);
				int mmmm = (rand() % NofNodes);
				if (llll + 1 != mmmm + 1) {
					if (d[llll][mmmm] < delta1) {
						//	if (d[llll][mmmm] > 40){
						if ((llll < NofCommNodes) && (mmmm < NofCommNodes)) {


							if (w[llll][mmmm] == 0) {



								int l2 = 0;
								int l3 = 0;
								int delta1orgstatus = 0; int delta1orgstatus1 = 0;

								//while ((delta1orgstatus == 0) || (delta1orgstatus12 == 0)){

								for (int l2 = 0; l2 < NofNodes - NofCommNodes; l2++) {

									if ((d[llll][l2 + NofCommNodes] <= delta1Org)) {
										delta1orgstatus = 1;
										//cout << " Short1: done" << endl;
										for (int l3 = 0; l3 < NofNodes - NofCommNodes; l3++) {

											if ((d[mmmm][l3 + NofCommNodes] <= delta1Org)) {

												w[llll][mmmm] = (rand() % 11) + 10;
												sd += 1;
												delta1orgstatus1 = 1;
												break;
											}
											//		else if (l3 == NofNodes - NofCommNodes - 1) { cout << " Short2: Not done" << endl; }

										}

									}
									if (delta1orgstatus1 == 1) {

										//	cout << " Long2: done" << endl;
										break;
									}
								}

								//	else if (l2 == NofNodes - NofCommNodes - 1) { cout << " Short1: Not done" << endl; }
							}
						}
					}
				}
				//	}

				//	}
				//	else {
				//		break;
				//	}
				//}
				//}
				//else {
				//cout << "amin" << endl;
				//	break;
				//}
			}

			//		cout << sd << endl;
			//		system("pause");
			int cfck = 0;
			for (int i = 0; i < NofNodes; i++) {
				for (int j = 0; j < NofNodes; j++) {
					if (w[i][j] > 0) {
						cfck += 1;
					}
				}
			}
			//	cout << cfck << endl;
			//	system("pause");
			//		cout << ami << endl;
			//cout << ld << endl;

			//cout << md << endl;
			//cout << sd << endl;
			//		cout << q1 << endl;
			//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
			//	}
			//	else { break; }
			//}
			///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	system("pause");





			//system("pause");
			int sumdis = 0;

			for (int i = 0; i < NofNodes; i++) {
				for (int j = 0; j < NofNodes; j++) {
					if (j > i)
						sumdis += d[i][j];
				}
			}
			float avedis = (sumdis / sizedis);


			ld = 0;
			for (int i = 0; i < NofNodes; i++) {
				for (int j = 0; j < NofNodes; j++) {
					if (i + 1 != j + 1) {
						if (d[i][j] > delta2) {
							if (w[i][j] > 0) {
								ld += 1;


							}
						}
					}
				}
			}
			md = 0;
			for (int i = 0; i < NofNodes; i++) {
				for (int j = 0; j < NofNodes; j++) {
					if (i + 1 != j + 1) {
						if (d[i][j] <= delta2) {
							if (delta1 < d[i][j]) {
								if (w[i][j] > 0){
									md += 1;

							}
						}
					}
				}
			}
		}

			sd = 0;
			for (int i = 0; i < NofNodes; i++) {
				for (int j = 0; j < NofNodes; j++) {
					if (i + 1 != j + 1) {
						if (d[i][j] <= delta1) {
							if (w[i][j] > 0) {
								sd += 1;

							}
						}
					}
				}
			}


			//#############################################################################################################################################
			//#############################################################################################################################################
			//#############################################################################################################################################
			//#############################################################################################################################################
			//#############################################################################################################################################
			//#############################################################################################################################################
			//#############################################################################################################################################
			//############################################################################################################################################# for 60

			if (avestatus == 1) {
				if (avedis < GoodAveDis) {//

					//	solstatus = 1;
				}			//####################################################################################################################
				else {
					//	cout << it << " " << avedis << endl;
				}
				if (avedis > GoodAveDis) {

					//	solstatus = 1;
				}
			}













			//#############################################################################################################################################
			float noofy1 = 0;
			float noofy2 = 0;

			for (int i = 0; i < NofNodes; i++)
				if (nodey[i] > 60)
					noofy1 += 1;

			for (int i = 0; i < NofNodes; i++)
				if (nodey[i] < 40)
					noofy2 += 1;

			if (((noofy1 / NofNodes) < 0.6) && ((noofy2 / NofNodes) < 0.6))
				//	solstatus = 1;

				noofy1 = 0;
			noofy2 = 0;





			//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&to check all dis be less that 40 ==delta 2 real
			for (int i = 0; i < NofNodes; i++) {
				for (int j = 0; j < NofNodes; j++) {
					if (i != j) {
						if (d[i][j] < delta2Org) {
							dstate[i] += 1;
							//	break;
						}
					}
				}
			}
			//00000000000000000000000000000000000000000000000 
			float sumsolstatus = 0;
			int solstatus1[NofNodes];
			for (int i = 0; i < NofNodes; i++) {
				solstatus1[i] = 0;
			}
			for (int i = 0; i < NofNodes; i++) {
				if (dstate[i] < PofCommNodesRegion*NofNodes + 1) {
					solstatus1[i] = 1;
				}
			}
			for (int i = 0; i < NofNodes; i++) {
				sumsolstatus += solstatus1[i];

			}
			//	if (sumsolstatus < 0.3*NofNodes)
			//		solstatus = 1;
			//	if (sumsolstatus > 0.1*NofNodes)
			//		solstatus = 1;

			//##############################################################################################

			int HState[NofNodes];
			float SumHState = 0;

			for (int i = 0; i < NofNodes; i++) {
				HState[i] = 0;
			}
			for (int i = 0; i < NofNodes; i++) {
				for (int j = 0; j < NofNodes; j++) {
					if (i != j) {
						if ((d[i][j] <= 40) && (d[i][j] >= 32)) {
							HState[i] = 1;
							break;
						}
					}
				}
			}

			for (int i = 0; i < NofNodes; i++) {

				SumHState += HState[i];
			}
			if ((NofNodes - SumHState) < 0.1*NofNodes) {//23

				//	solstatus = 1;
			}		//#############################################################################################################################################
			//	system("pause");
			//cout << it << " " << avedis << " " << float(NofNodes - SumHState) / NofNodes << " " << sd << endl;
		//***	cout << " avedis=" << avedis << endl; //" " << float(NofNodes - SumHState) / NofNodes << " " << sd << endl;<< it










			for (int i = 0; i < NofNodes; i++) {
				for (int j = 0; j < NofNodes; j++) {
					if (i + 1 != j + 1) {
						if (d[i][j] > sqrt(150 * 150 + 100 * 100)) {

							//#####################################################################################################################
							//			solstatus = 1;
						}
					}
				}
			}


			if ((md < (NofNodes*NofNodes - NofNodes)*0.4)) {//80
				//	if ((md>(NofNodes*NofNodes - NofNodes)*0.3)){//60 final%%%%%%%%%%%%%%%%%%%%%%%%
				//a	if ((ld>(NofNodes*NofNodes - NofNodes)*0.47) ){//80 43

				//aaa			solstatus = 1;
			}			//####################################################################################################################






			if ((sd < (NofNodes*NofNodes - NofNodes)*0.25)) {//80 25


				//a				solstatus = 1;
			}			//####################################################################################################################
			///////////////////////////////////////////////////////////////////////000000000000000000000000000000000000000000000000000000
			if ((avedis > 57) || (avedis < 53))//##########################################
				solstatus = 1;
			if (solstatus == 0) {


				////////////////////
				int sumweightO = 0;
				for (int i = 0; i < NofNodes; i++) {
					if (HPossibility[i] == 0) {
						sumweightO = 0;
						for (int j = 0; j < NofNodes; j++) {
							if (HPossibility[j] == 0) {
								sumweightO += w[i][j];
							}
						}
						//cout << sumweightO << endl;
						if (sumweightO == 0) {
							finalstatus = 1;
							//	cout << "Not good O; Repeat." << endl;
							//	system("pause");
						}
					}
				}


				if (finalstatus == 0) {
					int sumweightD = 0;
					for (int j = 0; j < NofNodes; j++) {
						if (HPossibility[j] == 0) {
							sumweightD = 0;
							for (int i = 0; i < NofNodes; i++) {
								if (HPossibility[i] == 0) {
									sumweightD += w[i][j];
								}
							}
							if (sumweightD == 0) {
								finalstatus = 1;
								//	cout << "Not good D; Repeat." << endl;
								//	system("pause");
							}
						}
					}
				}

				////////////////////////////////////////////
				if (finalstatus == 0) {



					//	cout << "Good one " << endl;
					//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
					///////////////////////////////////////////////////////
					////////////////////////////////////////////////////////////////////////////////////////////////////
					/////////////////////// txt w ////////////////////
					int ii = 0;

					TestProblem << "[[";
					for (int i = 0; i < NofNodes - 1; i++) {
						for (int j = 0; j < NofNodes - 1; j++) {

							TestProblem << w[i][j] << ",";
							ii = i;
						}

						TestProblem << w[ii][NofNodes - 1];
						TestProblem << "]," << endl;

						TestProblem << "[";
					}
					for (int j = 0; j < NofNodes - 1; j++) {
						TestProblem << w[NofNodes - 1][j] << ",";
					}
					TestProblem << w[NofNodes - 1][NofNodes - 1];
					TestProblem << "]]" << endl;

					//////////////////// txt d ////////////////

					TestProblem << "[[";
					for (int i = 0; i < NofNodes - 1; i++) {
						for (int j = 0; j < NofNodes - 1; j++) {

							TestProblem << d[i][j] << ",";
							ii = i;
						}
						//cout <<ii ;
						//system("pause");
						TestProblem << d[ii][NofNodes - 1];
						TestProblem << "]," << endl;

						TestProblem << "[";
					}
					for (int j = 0; j < NofNodes - 1; j++) {
						TestProblem << d[NofNodes - 1][j] << ",";
					}
					TestProblem << d[NofNodes - 1][NofNodes - 1];
					TestProblem << "]]" << endl;
					/*	/////////////////////// txt g ////////////////////
					TestProblem << "[[";
					for (int i = 0; i < NofNodes - 1; i++){
					for (int j = 0; j < NofNodes - 1; j++){

					TestProblem << g[i][j] << ",";
					ii = i;
					}
					//cout <<ii ;
					//system("pause");
					TestProblem << g[ii][NofNodes - 1];
					TestProblem << "]," << endl;

					TestProblem << "[";
					}
					for (int j = 0; j < NofNodes - 1; j++){
					TestProblem << g[NofNodes - 1][j] << ",";
					}
					TestProblem << g[NofNodes - 1][NofNodes - 1];
					TestProblem << "]]" << endl;*/
					/////////////////////// txt f ////////////////////
					TestProblem << "[";
					for (int i = 0; i < NofNodes - 1; i++) {

						TestProblem << f[i] << ",";
					}
					TestProblem << f[NofNodes - 1];
					TestProblem << "]" << endl;  ////asli


					/////////////////////// txt Cordinate ////////////////////
					TestProblem << "[";
					for (int i = 0; i < NofNodes - 1; i++) {

						TestProblem << nodex[i] << ",";
					}
					TestProblem << nodex[NofNodes - 1];
					TestProblem << "]" << endl;  ////asli

					TestProblem << "[";
					for (int i = 0; i < NofNodes - 1; i++) {

						TestProblem << nodey[i] << ",";
					}
					TestProblem << nodey[NofNodes - 1];
					TestProblem << "]" << endl;  ////asli

					/////////////////////// txt HPossibility ////////////////////

					TestProblem << "[";
					for (int i = 0; i < NofNodes - 1; i++) {

						TestProblem << HPossibility[i] << ",";
					}
					TestProblem << HPossibility[NofNodes - 1];
					TestProblem << "]" << endl;  ////asli






					TestProblem << endl << NofNodes << "," << a * 100 << 100 * b << 100 * c << "," << Density << "," << delta1 << delta2 << endl;
					//	TestProblem << "PofCommNodes=" << PofCommNodes << "  GoodAveDis=" << GoodAveDis << endl;
				//	TestProblem << "NofCommNodes=" << NofCommNodes << " realNoC=" << cfck <<  endl;//"  GoodAveDis=" << GoodAveDis <<


				//	TestProblem << "No. of Zero Node D=" << NofNodes - SumHState << "   " << float(NofNodes - SumHState) / NofNodes << endl;
					float NetNodes = sumsolstatus / NofNodes;
				//	TestProblem << "No. of Net Node=" << NetNodes << ", " << sumsolstatus << endl;

					/*	TestProblem << "[[";
					for (int i = 0; i < NofNodes - 1; i++){
					TestProblem << cord[i][1] << ",";
					}
					TestProblem << cord[NofNodes - 1][1];
					TestProblem << "]," << endl << "[";  ////asli
					for (int i = 0; i < NofNodes - 1; i++){

					TestProblem << cord[i][2] << ",";
					}
					TestProblem << cord[NofNodes - 1][2];
					TestProblem << "]]" << endl;*/


					//TestProblem << endl << endl << "Ave. Dis.=" << avedis << endl << endl;
					TestProblem << "Long Dis #=" << ld << endl;
					TestProblem << "Medium Dis #=" << md << endl;
					TestProblem << "Small Dis #=" << sd << endl;




					// for excel
					/*TestProblem << "[[";
					for (int i = 0; i < NofNodes - 1; i++) {
						TestProblem << nodex[i] << endl;
					}
					TestProblem << nodex[NofNodes - 1];
					TestProblem << "]]" << endl;

					TestProblem << "[[";
					for (int i = 0; i < NofNodes - 1; i++) {
						TestProblem << nodey[i] << endl;
					}
					TestProblem << nodey[NofNodes - 1];
					TestProblem << "]]" << endl;*/

					/////////////////////////////////////////////////////////////////////


					/*
					for (int i = 0; i < NofNodes; i++) {
						TestProblemInIn << nodex[i] << endl;
					}

					for (int i = 0; i < NofNodes; i++) {
						TestProblemInIn << nodey[i] << endl;
					}
					/////////////////////////////////////////////////////////////////

					for (int i = 0; i < NofNodes; i++) {
						for (int j = 0; j < NofNodes; j++) {
							TestProblemInIn << w[i][j] << endl;
						}
					}

					for (int i = 0; i < NofNodes; i++) {
						TestProblemIn << nodex[i] << endl;
					}

					for (int i = 0; i < NofNodes; i++) {
						TestProblemIn << nodey[i] << endl;
					}
					*/


					////////////////////////////////////////////


					cout << endl << "***done*** " << endl;
					system("pause");
					break;
				}
				else {
					//cout << it << " Not good ; Repeat." << endl;

				}
			}

			//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
		}
	}//for iteration

	return 0;
}